# NodBot v4
This repository is my working repo for a ground-up rewrite of NodBot's code to make it more stable and usable.

# Dependencies
* `dotenv`
* `discord.js`
* `fs` (built in)
* `@discordjs/collection`

# TODO:
- Check on error handling and log outputs

# DONE:
- Initial setup, bot currently starts up, connects, and sends the startup message.

# Current Commit Status:
[ BRANCH: main ]
No work has been done, this is just the template so far.

# Roadmap
* Database schema restructure to include important information like creation date, edit date, creator, editor, etc
* Something for deduplication in the databases
* Improve content management interfaces
* Improve content caching and establish a fallback procedure to check the database if the content isn't cached, this will remove the reloads
* Update `.spongebob` so that it handles replies properly, detecting if the replied message or the replying message should be sb'd
* Add a .shed command for shedfakes
* Google search
* Youtube search, maybe implementing the head-emojis of popular youtubers like Tech Connections, Tom Scott, etc.
* METAR/TAF retrieval
* [-] Add some recursive command detection for something like `This is a message {nod.gif}` which would treat `nod.gif` as a command
* Clean up Joints database, specifically strain names, attempt to find more data
* Add some other file extension aliases, `.wav` in particular
* Meme generator, possibly look into seeing if imgflip has an API

# Recent non-versioned upgrades
* Implemented `Ashtray` and `Bowl Screen` to reduce redundant and repetitive `.joint`s
* Removed pseudo-random capitalization in `.spongebob`
